<?php

//  Copyright (C) 2002-2006 Balint Kis (balint-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

$dayNames = array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
$dayNamesShort = array("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat");
$monthNames = array(1 => "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
$daysInMonth = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

function display_hour_combo($identifier, $value, $display_null) {
  print "<select name=\"$identifier\">\n";
  if ($display_null != "") {
    print "<option value=\"\" selected>";
  }
  for ($i = 0; $i < 24; $i++) {
    if ($value == $i)
      print "<option value=\"$i\" selected>";
    else
      print "<option value=\"$i\">";
    printf("%02d", $i);
  }
  print "</select>\n";
}

function display_minute_combo($identifier, $value) {
  print "<select name=\"$identifier\">\n";
  print "<option value=\"\" selected>";
  for ($i = 0; $i < 60; $i += 5) {
    if ($value == $i)
      print "<option value=\"$i\" selected>";
    else
      print "<option value=\"$i\">";
    printf("%02d", $i);
  }
  print "</select>\n";
}

function compare_timestamps($timestamp_1, $timestamp_2) {
  if (($timestamp_1 == "") || ($timestamp_2 ==""))
    return 0;

  $year_1 = substr($timestamp_1,  0, 4);
  $year_2 = substr($timestamp_2,  0, 4);
  if ($year_1 < $year_2)
    return 1;
  if ($year_1 > $year_2)
    return -1;

  $month_1 = substr($timestamp_1,  5, 2);
  $month_2 = substr($timestamp_2,  5, 2);
  if ($month_1 < $month_2)
    return 1;
  if ($month_1 > $month_2)
    return -1;

  $day_1 = substr($timestamp_1,  8, 2);
  $day_2 = substr($timestamp_2,  8, 2);
  if ($day_1 < $day_2)
    return 1;
  if ($day_1 > $day_2)
    return -1;

  $hour_1 = substr($timestamp_1, 11, 2);
  $hour_2 = substr($timestamp_2, 11, 2);
  if ($hour_1 < $hour_2)
    return 1;
  if ($hour_1 > $hour_2)
    return -1;

  $minute_1 = substr($timestamp_1, 14, 2);
  $minute_2 = substr($timestamp_2, 14, 2);
  if ($minute_1 < $minute_2)
    return 1;
  if ($minute_1 > $minute_2)
    return -1;

  $second_1 = substr($timestamp_1, 17, 2);
  $second_2 = substr($timestamp_2, 17, 2);
  if ($second_1 < $second_2)
    return 1;
  if ($second_1 > $second_2)
    return -1;

  return 0;
}

function display_date_input_form($tag_id, $timestamp) {
  if ($timestamp) {
    $year  = substr($timestamp, 0, 4);
    $month = substr($timestamp, 5, 2);
    $day   = substr($timestamp, 8, 2);
    $hour   = substr($timestamp, 11, 2);
    $min   = substr($timestamp, 14, 2);
    $sec   = substr($timestamp, 17, 2);
    $timestamp = "$year-$month-$day $hour:$min:$sec";
    $display_timestamp = date ("l, F d, Y H:i:s", mktime ($hour, $min, $sec, $month, $day, $year));
    $display_title = "Click to adjust date";
  } else {
    $timestamp = "null";
    $display_timestamp = "NOT ENTERED";
    $display_title = "Click to set date";
  }
  print "<span id=\"show_$tag_id\" style=\"border: 1px solid cornflowerblue;\" title=\"$display_title\" onmouseover=\"this.style.background='cornflowerblue';\" onmouseout=\"this.style.background=''\" >$display_timestamp</span>&nbsp;&nbsp;";
  print "<input type=\"hidden\" name=\"$tag_id\" id=\"field_$tag_id\" value=\"$timestamp\" readonly=\"1\" />";
  print "<script type=\"text/javascript\">\n";
  print "Calendar.setup({\n";
  print "singleClick: true,\n";
  print "inputField:  \"field_$tag_id\",\n";
  print "displayArea: \"show_$tag_id\",\n";
  print "button:      \"show_$tag_id\",\n";
  print "daFormat:    \"%A, %B %d, %Y %k:%M:%S\",\n";
  print "ifFormat:    \"%Y-%m-%d %k:%M:%S\",\n";
  print "align:       \"Tl\",\n";
  print "range:       [1900, 2100]\n";
  print "});\n";
  print "</script>\n";
}

function check_date_validity($timestamp) {
  if ($timestamp == "null")
    return "null";

  $year  = substr($timestamp, 0, 4);
  $month = substr($timestamp, 5, 2);
  $day   = substr($timestamp, 8, 2);

  if (checkdate($month, $day, $year)) {
    $date = $timestamp;
  } else {
    $today = getdate();
    $date = sprintf("%04d-%02d-%02d", $today['year'], $today['mon'], $today['mday']);
  }
  return "'" . $date . "'";
}

function generate_date_html($timestamp, $format, $link) {
  $month_string_short = array('NULL','Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
  $month_string_long  = array('NULL','January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');

  if (!$timestamp)
    return "";

  switch ($format) {
  case 'full':
  case 'date':
  case 'short_date':
    $year  = substr($timestamp, 0, 4);
    $month = substr($timestamp, 5, 2);
    $day   = substr($timestamp, 8, 2);
    if ($format=='short_date')
      $month_string = $month_string_short;
    else
      $month_string = $month_string_long;

    for ($counter=0; $counter < $month; $counter++)
      next($month_string);
    $current_month_string = current($month_string);

    if ($format=='date')
      break;
  case 'time':
    $time = substr($timestamp, 11, 5);
  }

  $html_string = "";
  switch ($format) {
  case 'full':
    if ($link)
      $html_string .= "<a href=\"my.datebook.php?view=1&year=$year&month=$month&day=$day\">$current_month_string $day, $year</a> at $time";
    else
      $html_string .= "$current_month_string $day, $year at $time";
    break;
  case 'date':
  case 'short_date':
    if ($link)
      $html_string .= "<a href=\"my.datebook.php?view=1&year=$year&month=$month&day=$day\">$current_month_string $day, $year</a>";
    else
      $html_string .= "$current_month_string $day, $year";
    break;
  case 'time':
    $html_string .= "$time"; break;
  }
  return $html_string;
}


function display_time($time, $format) {
  switch ($format) {
  case 'full':
    print "$time";
    break;
  case 'minute':
    $minute = substr($time, 3, 2);
  case 'hour':
    $hour   = substr($time, 0, 2);
    print "$hour";
    if ($minute != "")
      print ":$minute";
  }
}


function getDaysInMonth($year, $month) {
  if ($month < 1 || $month > 12)
    return 0;

  $daysInMonth = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
  $day = $daysInMonth[$month - 1];

  if ($month == 2) {
    if ($year%4 == 0) {
      if ($year%100 == 0) {
        if ($year%400 == 0)
          $day = 29;
      }
      else
        $day = 29;
    }
  }
  return $day;
}

function getDayNumberOfDate($year, $month, $day) {
  $nday = 0;
  for ($mcounter = 1; $mcounter < $month; $mcounter++)
    $nday += getDaysInMonth($year, $mcounter);
  return $nday + $day;
}

function getDateOfDayNumber($year, $day) {
  $dateOfDay = array();
  $dateOfDay[0] = $year;
  for ($mcounter = 1; $mcounter < 13; $mcounter++) {
    $daysInThisMonth = getDaysInMonth($year, $mcounter);
    if ($day > $daysInThisMonth) {
      $day -= $daysInThisMonth;
      continue;
    }
    break;
  }
  $dateOfDay[1] = $mcounter;
  $dateOfDay[2] = $day;
  return adjustDay($dateOfDay[0], $dateOfDay[1], $dateOfDay[2]);;
}

function getWeekNumber($year, $month, $day, $startDay) {
  // get timestamp of first day of the year at noon
  $timestamp = mktime(12, 0, 0, 1, 1, $year);
  // get first day index 0 Sunday
  $date = getdate($timestamp);
  $days = $date["wday"] + getDayNumberOfDate($year, $month, $day) - $startDay;
  $weekNumber = ceil($days/7);
  if ($weekNumber>52)
    $weekNumber -= 52;
  return $weekNumber;
}

function getFirstDayOfWeek($year, $week, $startDay) {
  // get timestamp of first day of the year at noon
  $timestamp = mktime(12, 0, 0, 1, 1, $year);
  // get first day index 0 Sunday
  $date = getdate($timestamp);
  $firstDayOfWeek = ($week - 1) * 7 - $date["wday"] + 1 + $startDay;
  return getDateOfDayNumber($year, $firstDayOfWeek);
}

function adjustMonth($year, $month) {
  $newDate = array();
  $newDate[0] = $year;
  $newDate[1] = $month;

  if ($month < 1) {
    $newDate[0] = $year - 1;
    $newDate[1] = 12 + $month;
  }
  if ($month > 12) {
    $newDate[0] = $year + 1;
    $newDate[1] = $month - 12;
  }
  return $newDate;
}

function adjustDay($year, $month, $day) {
  $newDate = array();
  $newDate[0] = $year;
  $newDate[1] = $month;
  $newDate[2] = $day;

  $daysInCurrentMonth = getDaysInMonth($year, $month);

  if ($day < 1) {
    $previousMonth = adjustMonth($year, $month - 1);
    $newDate[0] = $previousMonth[0];
    $newDate[1] = $previousMonth[1];
    $daysInPreviousMonth = getDaysInMonth($newDate[0], $newDate[1]);
    $newDate[2] = $daysInPreviousMonth + $day;
  }
  if ($day > $daysInCurrentMonth) {
    $nextMonth = adjustMonth($year, $month + 1);
    $newDate[0] = $nextMonth[0];
    $newDate[1] = $nextMonth[1];
    $newDate[2] = $day - $daysInCurrentMonth;
  }
  return $newDate;
}
?>
