<?php

//  Copyright (C) 2002-2006 Balint Kis (balint-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
include_once "$theme/theme.php";

$session_id = $_COOKIE[$po_cookie];
if ($session_id == "") {
  header("location: login.php");
  exit();
}

include_once "include/calendar.php";

function update_scanner($database, $user_id, $scanner_id, $scanner_type_id, $scanner_manufacturer_id, $scanner_model, $scanner_variation,
                     $scanner_serial_number, $scanner_purchase_timestamp, $scanner_purchased_new, $scanner_access_rights) {

  $scanner_date_of_purchase = check_date_validity($scanner_purchase_timestamp);

  pg_query($database, "begin");
  if ($scanner_type_id=='custom') {
    /* scanner type has changed */
    $number_of_scanneres_of_same_type = pg_fetch_row(pg_query($database, "select count(identifier) from scanner where type=(select type from scanner where identifier='$scanner_id')"));
    if ($number_of_scanneres_of_same_type[0] == 1) {
      /* there was only one scanner of this kind, so we have to remove it */
      $scanner_type_to_remove = pg_fetch_row(pg_query($database, "select type from scanner where identifier='$scanner_id'"));
    }
    /* create new type */
    $new_scanner_type_id = pg_fetch_row(pg_query($database, "select nextval('scanner_type_id_sequence')"));
    $scanner_type_id = $new_scanner_type_id[0];
    $result = pg_query($database, "insert into scanner_type (identifier, manufacturer, model, variation, last_modified_date, last_modifying_users)
                                   values ($scanner_type_id, $scanner_manufacturer_id, '$scanner_model', '$scanner_variation', now(), $user_id)");
    if (!$result) {
      print "Failed to create new scanner type";
      pg_query($database, "rollback");
      return;
    }
  }

  /* add scanner */
  $result = pg_query($database, "update scanner set type=$scanner_type_id, serial_number='$scanner_serial_number', date_of_purchase=$scanner_date_of_purchase, purchased_new='$scanner_purchased_new', access_rights='$scanner_access_rights'  where identifier='$scanner_id'");
  if (!$result) {
    print "Failed to create new scanner";
    pg_query($database, "rollback");
    return;
  }

  /* remove old type */
  if ($scanner_type_to_remove) {
    $result = pg_query($database, "delete from scanner_type where identifier='$scanner_type_to_remove[0]'");
    if (!$result) {
      print "Failed to delete scanner type: $scanner_type";
      pg_query($database, "rollback");
      return;
    }
  }
  pg_query($database, "commit");
}

$database = site_prolog();
$my_user_id = pg_fetch_row(pg_query($database, "select identifier from users where session_id='$session_id'"));
if ($my_user_id[0] == "") {
  site_epilog($database);
  header("location: login.php");
  exit();
}

update_scanner($database, $my_user_id[0], $_REQUEST['item_id'], $_REQUEST['scanner_type_id'], $_REQUEST['scanner_manufacturer_id'], $_REQUEST['scanner_model'], $_REQUEST['scanner_variation'],
               $_REQUEST['scanner_serial_number'], $_REQUEST['scanner_purchase_timestamp'], $_REQUEST['scanner_purchased_new'], $_REQUEST['scanner_access_rights']);

site_epilog($database);
header("location: my.profile.php?selector=".$profile_data['scanner']['idx']);

?>
