<?php

//  Copyright (C) 2002-2006 Balint Kis (balint-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/orderby.php";
include_once "include/stemming.php";
include_once "include/search.php";
include_once "include/site.php";
include_once "$theme/theme.php";

function display_search_operator($item_name, $value) {
  print "<select name=\"$item_name\">\n";
  if ($value == 'and') {
    print "<option value=\"or\">UNION";
    print "<option value=\"and\" selected>INTERSECT";
  }
  else {
    print "<option value=\"or\" selected>UNION";
    print "<option value=\"and\">INTERSECT";
  }
  print "</select>\n";
}

function display_advanced_search_entry($database, $search_data, $search_operator) {
  global $theme;
  global $style;
  global $search_interface;

  print "&nbsp;<br/>\n";

  display_navigator_box_top($search_interface['text_advanced']['idx'], $search_interface, "100%");

  print "&nbsp;<br/>";
  print "<table align=\"center\" border=\"0\">";
  print "<tr><td  align=\"left\"  colspan=\"2\">";

  print "<table width=\"100%\">";

  print "<tr><td align=\"right\">Identifier&nbsp;</td><td >";
  print "<input type=\"text\" name=\"identifier\" value=\"".$search_data['identifier']."\" size=\"50\"></td><td>";
  display_search_operator("identifier_operator", $search_operator['identifier']);
  print "</td></tr>";

  print "<tr><td align=\"right\">Title&nbsp;</td><td >";
  print "<input type=\"text\" name=\"title\" value=\"".$search_data['title']."\" size=\"50\"></td><td>";
  display_search_operator("title_operator", $search_operator['title']);
  print "</td></tr>";

  print "<tr><td align=\"right\">Author&nbsp;</td><td >";
  print "<input type=\"text\" name=\"author\" value=\"".$search_data['author']."\" size=\"50\"></td><td>";
  display_search_operator("author_operator", $search_operator['author']);
  print "</td></tr>";

  print "<tr><td align=\"right\">Keyword&nbsp;</td><td >";
  print "<input type=\"text\" name=\"keyword\" value=\"".$search_data['keyword']."\" size=\"50\"></td><td>";
  display_search_operator("keyword_operator", $search_operator['keyword']);
  print "</td></tr>";

  print "<tr><td align=\"right\">Caption&nbsp;</td><td >";
  print "<input type=\"text\" name=\"caption\" value=\"".$search_data['caption']."\" size=\"50\"></td><td>";
  display_search_operator("caption_operator", $search_operator['caption']);
  print "</td></tr>";

  print "<tr><td align=\"right\">Location&nbsp;</td><td >";
  print "<input type=\"text\" name=\"location\" value=\"".$search_data['location']."\" size=\"50\"></td><td>";
  display_search_operator("location_operator", $search_operator['location']);
  print "</td></tr>";
  print "</table>";

  print "</td></tr>";
  print "<tr><td align=\"center\"   colspan=\"2\">";
  print "<input type=\"image\" src=\"$theme/button.search.gif\" border=\"0\" value=\"Search\">\n";
  print "</td></tr>";
  print "</table>";

  display_navigator_box_bottom("100%");

  print "&nbsp;<br/>\n";
}

$num_of_rows_l  = $default_num_of_rows_in_list_view;
$num_of_rows    = $default_num_of_rows_in_slide_view;
$num_of_columns = $default_num_of_columns;
$popup_enable   = $default_popup_enable;
$popup_delay    = $default_popup_delay;

$search_data['identifier'] = validate_search_string($_REQUEST['identifier']);
$search_data['title']      = validate_search_string($_REQUEST['title']);
$search_data['author']     = validate_search_string($_REQUEST['author']);
$search_data['keyword']    = validate_search_string($_REQUEST['keyword']);
$search_data['caption']    = validate_search_string($_REQUEST['caption']);
$search_data['location']   = validate_search_string($_REQUEST['location']);

$search_operator['identifier'] = $_REQUEST['identifier_operator'];
$search_operator['title']      = $_REQUEST['title_operator'];
$search_operator['author']     = $_REQUEST['author_operator'];
$search_operator['keyword']    = $_REQUEST['keyword_operator'];
$search_operator['caption']    = $_REQUEST['caption_operator'];
$search_operator['location']   = $_REQUEST['location_operator'];

$order_by       = $_REQUEST['order_by'];
if (!$order_by) {
  $order_by = 1;
}

$sql_query_order_by_string = $order_by_string[$order_by][0];
$ignored_keywords = "";

$session_id    = $_COOKIE[$po_cookie];
$database      = site_prolog();
$my_user_id    = pg_fetch_row(pg_query($database, "select identifier, type from users where session_id='$session_id'"));
$offset        = $_REQUEST['offset'];
if (!$offset) {
  $offset = 0;
}

if ($my_user_id[0]!="") {
  $preferences = pg_fetch_row(pg_query($database, "
     select num_of_rows, num_of_columns, popup_enable, popup_delay, search_enable_stemming
       from users, preferences
      where preferences.identifier=users.preferences
        and users.identifier=$my_user_id[0]"));
  $num_of_rows     = $preferences[0];
  $num_of_columns  = $preferences[1];
  $popup_enable    = $preferences[2];
  $popup_delay     = $preferences[3];
  $enable_stemming = $preferences[4];
}

site_header($page_width, "Advanced Search");
site_navigator(2, $my_user_id[1]);

$keywords['identifier'] = extract_keywords($search_data['identifier'], $enable_stemming);
$keywords['title']      = extract_keywords($search_data['title'], $enable_stemming);
$keywords['author']     = extract_keywords($search_data['author'], $enable_stemming);
$keywords['keyword']    = extract_keywords($search_data['keyword'], $enable_stemming);
$keywords['caption']    = extract_keywords($search_data['caption'], $enable_stemming);
$keywords['location']   = extract_keywords($search_data['location'], $enable_stemming);

if (!$search_data['identifier'] &&
    !$search_data['title'] &&
    !$search_data['author'] &&
    !$search_data['keyword'] &&
    !$search_data['caption'] &&
    !$search_data['location']) {
  site_navigator_status("Type search string below:", "");
  print "<form action=\"search.text.advanced.php\" method=\"post\">";
  display_advanced_search_entry($database, $search_data, $search_operator);
  if ($ignored_keywords != "") {
    print "&nbsp;<br/>\n";
    print "<div align=\"center\" >\n";
    print "The following keywords were ignored: $ignored_keywords<br/>";
    print "Use quotation marks to force the search engine to include these keywords.";
    print "</div></p>\n";
  }
  print "&nbsp;<br/>\n";
  print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/wz_tooltip.js\"></script>";
  site_footer($database);
  site_epilog($database);
  exit();
}

$status_string="Displaying photos";

$sql_search_string['identifier'] = build_sql_search_string($keywords['identifier'], "photo.identifier");
$sql_search_string['title']      = build_sql_search_string($keywords['title'],      "photo.title");
$sql_search_string['author']     = build_sql_search_string($keywords['author'],     "photo.author");
$sql_search_string['keyword']    = build_sql_search_string($keywords['keyword'],    "photo.keyword");
$sql_search_string['caption']    = build_sql_search_string($keywords['caption'],    "photo.caption");
$sql_search_string['location']   = build_sql_search_string($keywords['location'],   "(view_location.place|||view_location.city|||view_location.state|||view_location.country)");

$sql_combined_search_string = "";

if ($sql_search_string['identifier'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['identifier']." " .$sql_search_string['identifier'];
  else
    $sql_combined_search_string = $sql_search_string['identifier'];
}

if ($sql_search_string['title'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['title']." " .$sql_search_string['title'];
  else
    $sql_combined_search_string = $sql_search_string['title'];
}

if ($sql_search_string['author'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['author']." " .$sql_search_string['author'];
  else
    $sql_combined_search_string = $sql_search_string['author'];
}

if ($sql_search_string['keyword'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['keyword']." " .$sql_search_string['keyword'];
  else
    $sql_combined_search_string = $sql_search_string['keyword'];
}

if ($sql_search_string['caption'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['caption']." " .$sql_search_string['caption'];
  else
    $sql_combined_search_string = $sql_search_string['caption'];
}

if ($sql_search_string['location'] != "") {
  if ($sql_combined_search_string != "")
    $sql_combined_search_string = $sql_combined_search_string ." ".$search_operator['location']." " .$sql_search_string['location'];
  else
    $sql_combined_search_string = $sql_search_string['location'];
}

/* this is just to avoid having three separate queries */
if ($sql_combined_search_string == "") {
  $sql_combined_search_string = "photo.identifier=null";
}

/* compute access rights */
if ($my_user_id[0] == "") {
  $sql_query_access_rights_string = "photo.access_rights = $access[public]";
}
else {
  $sql_query_access_rights_string = "((photo.access_rights = $access[public]) or
                                      (photo.access_rights = $access[protected] and $my_user_id[0] in (select client from client where users=photo.users)) or
                                      (photo.users = $my_user_id[0]))";
}

/* query number of matches */
$query_string = "
         select count(photo.identifier)
            from photo, folder, photo_dupe, photo_version, users, view_location
           where photo.folder = folder.identifier
             and photo.users = users.identifier
             and photo.identifier = photo_version.photo
             and photo.identifier = photo_dupe.photo
             and photo_version.master='t'
             and photo_dupe.key = 1
             and photo.location = view_location.identifier
             and ($sql_combined_search_string)
             and $sql_query_access_rights_string";

// print "<pre> $query_string </pre>";

$num_of_matches_a = pg_fetch_row(pg_query($database, $query_string));

$num_of_matches = $num_of_matches_a[0];

$offset = $_REQUEST['offset'];
if (!$offset) {
  $offset = 0;
}

$limit = $num_of_rows * $num_of_columns;
if ($limit > $num_of_matches) {
  $limit = $num_of_matches;
}

$query_string = 
        "select photo.identifier, photo_version.small_image_path, photo.caption, photo.date_of_exposure, photo_dupe.date_of_creation,
                 (select value from access_type where access_type.identifier=photo.access_rights) as access_rights,
                 11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
                 views,
                 (0) as for_sale,
                 photo.title, photo.author, photo.keyword,
                 photo_version.original_image_name, photo.users,
                 view_location.place, view_location.country, view_location.city, view_location.state
            from photo, folder, photo_dupe, photo_version, users, view_location
           where photo.folder = folder.identifier
             and photo.users = users.identifier
             and photo.identifier = photo_version.photo
             and photo.identifier = photo_dupe.photo
             and photo_version.master='t'
             and photo_dupe.key = 1
             and photo.location = view_location.identifier
             and ($sql_combined_search_string)
             and $sql_query_access_rights_string
           order by $sql_query_order_by_string
          offset $offset
           limit $limit";

# print "<pre> $query_string </pre>";

$search_result = pg_query($database,$query_string);

if ($num_of_matches == 0) {
  $itemized_search_string['identifier'] = build_itemized_search_string($search_data['identifier'], "identifier", "");
  $itemized_search_string['title']      = build_itemized_search_string($search_data['title'],      "title",      "");
  $itemized_search_string['author']     = build_itemized_search_string($search_data['author'],     "author",     "");
  $itemized_search_string['keyword']    = build_itemized_search_string($search_data['keyword'],    "keyword",    "");
  $itemized_search_string['caption']    = build_itemized_search_string($search_data['caption'],    "caption",    "");
  $itemized_search_string['location']   = build_itemized_search_string($search_data['location'],   "location",   "");

  site_navigator_status("No matches found for $itemized_search_string", "");
  print "<form action=\"search.text.advanced.php\" method=\"post\">";
  display_advanced_search_entry($database, $search_data, $search_operator);
  print "</form>";
  if ($ignored_keywords != "") {
    print "&nbsp;<br/>\n";
    print "<center>\n";
    print "The following keywords were ignored: $ignored_keywords<br/>";
    print "Use quotation marks to force the search engine to include these keywords.";
    print "</center></p>\n";
  }
  print "&nbsp;<br/>\n";
  print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/wz_tooltip.js\"></script>";
  site_footer($database);
  site_epilog($database);
  exit();
}

$itemized_search_string['identifier'] = build_itemized_search_string($search_data['identifier'], "identifier", "");
$itemized_search_string['title']      = build_itemized_search_string($search_data['title'],      "title",      "");
$itemized_search_string['author']     = build_itemized_search_string($search_data['author'],     "author",     "");
$itemized_search_string['keyword']    = build_itemized_search_string($search_data['keyword'],    "keyword",    "");
$itemized_search_string['caption']    = build_itemized_search_string($search_data['caption'],    "caption",    "");
$itemized_search_string['location']   = build_itemized_search_string($search_data['location'],   "location",   "");

site_navigator_status("Searched database for $itemized_search_string",  "Displaying photos " . display_photo_index_status($offset, $limit, $num_of_matches));
print "<form action=\"search.text.advanced.php\" method=\"post\">";
display_advanced_search_entry($database, $search_data, $search_operator);
print "</form>";
if ($ignored_keywords != "") {
  print "&nbsp;<br/>\n";
  print "<center>\n";
  print "The following keywords were ignored: $ignored_keywords<br/>";
  print "Use quotation marks to force the search engine to include these keywords.";
  print "</center>\n";
}
print "&nbsp;<br/>\n";


$arguments = "&search_type=$search_type&offset=$offset";

if ($order_by) {
  $arguments = $arguments . "&order_by=$order_by";
}

$search_string =
"identifier=".$search_data['identifier'].
"&title=".$search_data['title'].
"&author=".$search_data['author'].
"&keyword=".$search_data['keyword'].
"&caption=".$search_data['caption'].
"&location=".$search_data['location'].
"&identifier_operator=".$search_operator['identifier'].
"&title_operator=".$search_operator['title'].
"&author_operator=".$search_operator['author'].
"&keyword_operator=".$search_operator['keyword'].
"&caption_operator=".$search_operator['caption'].
"&location_operator=".$search_operator['location'];

$search_string_exp = str_replace(" ", "+", $search_string);

print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/select.js\"></script>";
print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/util.js\"></script>";

print "<form  name=\"photoList\" method=\"post\" action=\"folder.content.php\">";
print "<input type=\"hidden\" name=\"user\" value=\"$user_id\">";
print "<input type=\"hidden\" name=\"return\" value=\"search.text.advanced.php?search_string=$search_string$arguments\">";
print "<input type=\"hidden\" name=\"view\" value=\"$view\">";

if (($offset + $limit) > $num_of_matches) {
  $items = $num_of_matches - $offset;
}
else {
  $items = $limit;
}

display_photo_navigator("search_advanced", $arguments, $my_user_id[0], $search_string_exp, $offset, $limit, $num_of_matches);
$checkboxes = display_photo_slides("search_advanced", $my_user_id[0], $my_user_id[1], $folder_id, $search_result, $items, $num_of_columns, $popup_enable, $popup_delay, $shop_enable, true, $order_by);
display_photo_navigator("search_advanced", $arguments, $my_user_id[0], $search_string_exp, $offset, $limit, $num_of_matches);
print "&nbsp;<br/>\n";

$itemized_search_string['identifier'] = build_itemized_search_string($search_data['identifier'], "identifier", "");
$itemized_search_string['title']      = build_itemized_search_string($search_data['title'],      "title",      "");
$itemized_search_string['author']     = build_itemized_search_string($search_data['author'],     "author",     "");
$itemized_search_string['keyword']    = build_itemized_search_string($search_data['keyword'],    "keyword",    "");
$itemized_search_string['caption']    = build_itemized_search_string($search_data['caption'],    "caption",    "");
$itemized_search_string['location']   = build_itemized_search_string($search_data['location'],   "location",   "");

site_navigator_status("Searched database for $itemized_search_string",  "Displaying photos " . display_photo_index_status($offset, $limit, $num_of_matches));

print "<table align=\"left\" valign=\"middle\" cellpadding=\"0\" border=\"0\">";
print "<tr><td align=\"left\" valign=\"middle\">";

print "<table align=\"left\" valign=\"middle\" cellpadding=\"0\" border=\"0\">";
print "<tr>";
print "<td align=\"left\" valign=\"middle\">";
display_order_by_combo_with_button($order_by);
print "</td>";
if ($checkboxes > 0 && $my_user_id[0] != "") {
  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
  display_printto();
  print "</td>";
}
print "</tr>";
print "</table>";

print "</td></tr><tr><td align=\"left\" valign=\"middle\">";

print "<table align=\"left\" valign=\"middle\" cellpadding=\"0\" border=\"0\">";
print "<tr>";

if ($checkboxes > 0 && $my_user_id[0] != "") {
  $folder_all = pg_query($database, "select identifier, caption, parent_folder from folder where users=$my_user_id[0] order by date_of_creation desc");
  print "<td align=\"left\" valign=\"middle\">";
  display_moveto_folder($folder_all, $folder_id, "goto");
  print "</td>";

  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
  display_moveto_folder($folder_all, $folder_id, "moveto");
  print "</td>";

  $album_all = pg_query($database, "select identifier, caption, parent_album from 
album where users=$my_user_id[0] and type='u' order by date_of_creation desc");
  if (pg_num_rows($album_all) > 0) {
    print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
    display_linkto_album($album_all, $album_id);
    print "</td>";
  }

  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td><td align=\"left\" valign=\"middle\">";
  print "<a class=\"nodecor\" href=\"javascript:setChecked('photocb'); changeImage('selectButton', '$theme/button.deselect.all.gif', '$theme/button.select.all.gif')\"><img name=\"selectButton\" src=\"$theme/button.select.all.gif\" border=\"0\"></a>\n";
  print "</td>";
  print "</td>";
}
print "</tr>";
print "</table>";

print "</td></tr>";
print "</table>";
print "</form>";

print "&nbsp;<br/>\n";
print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/wz_tooltip.js\"></script>";
site_footer($database);
site_epilog($database);
?>
