
--  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.20 to v2.21 patch
----------------------------------------------------------

-- remove obsolete rows
alter table preferences drop column copyright_statement_photo;
alter table preferences drop column copyright_statement;

-- create imagemagick composite options table

create table imagemagick_composite_options (
  identifier              integer not null primary key,
  gravity                 varchar(20) check (gravity in ('center', 'northwest', 'north', 'northeast', 'west', 'center', 'east', 'southwest', 'south', 'southeast')),
  watermark               integer not null,
  photo_version           integer references photo_version(identifier)
);

alter table users add column imagemagick_composite_options integer references imagemagick_composite_options(identifier);
insert into imagemagick_composite_options (identifier, gravity, watermark, photo_version) select imagemagick_options, 'southeast' as gravity, 50 as watermark, null as photo_version from users;
update users set imagemagick_composite_options = imagemagick_options;
alter table users alter column imagemagick_composite_options set not null;

create sequence imagemagick_composite_options_id_sequence;
select setval('imagemagick_composite_options_id_sequence', max(imagemagick_composite_options)) from users;

-- create dcraw options table
create table dcraw_options (
  identifier              integer not null primary key,
  gamma                   float,
  brightness              float,
  white_balance           varchar(10) check (white_balance in ('camera', 'automatic')),
  red_multiplier          float,
  blue_multiplier         float,
  bitdepth                integer check (bitdepth in (24, 48))
);

alter table users add column dcraw_options integer references dcraw_options(identifier);
insert into dcraw_options (identifier, gamma, brightness, white_balance, red_multiplier, blue_multiplier, bitdepth)
   select imagemagick_options, 0.6, 1.0, 'automatic', 1.0, 1.0, 24 from users;
update users set dcraw_options = imagemagick_options;
alter table users alter column dcraw_options set not null;

create sequence dcraw_options_id_sequence;
select setval('dcraw_options_id_sequence', max(dcraw_options)) from users;
